/* ----------------------------------------------------------------- *
   Copyright (c) 1997 Hitachi Microsoftware Systems, Inc.
   All rights reserved.
 * ----------------------------------------------------------------- */

#ifndef __common_h__
#define __common_h__

/* ----------------------------------------------------------------- */
#define TRUE  1
#define FALSE 0
#ifndef NULL
#define NULL 0
#endif

#define LINEBUFSIZ 256

#define CONFIG_FILE_SEARCH_PATH ".;" PATH_ETC
#define CONFIG_FILE_NAME        "bjorb.conf"
#define PIDFILE   "/var/run/bjorb.pid"

/* max hostname length */
#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 256
#endif

/* max filename length */
#ifndef NAME_MAX
#define NAME_MAX 255
#endif
#define FILENAMELEN (NAME_MAX + 1)

#ifndef BOOL
#define BOOL int
#endif

typedef int SOCKET;

/* ----------------------------------------------------------------- */

#ifdef __cplusplus
#include "log.h"

extern Logger stderrLog;
extern Logger *elogp;
extern int log_level;

#if 1
#define PUTERR(level, body) ((log_level >= level) ? (elogp->setLevel(level),elogp->put body),0 : 0)
#else
#define PUTERR(level, body) (elogp ? ((log_level >= level) ? (elogp->setLevel(level),elogp->put body) : 0) : ((log_level >= level) ? stderrLog.setLevel(level),stderrLog.put body : 0))
#endif

extern "C" {
#endif

/* ----------------------------------------------------------------- */

/* For interchangeability between UNIX and win32 */
#ifdef _WINDOWS

#define NO_SYSLOG

#define STRCHR     lstrchr
#define STRCPY	   lstrcpy
#define STRCMP     lstrcmp
#define STRLEN     lstrlen
#define STRCASECMP stricmp
#define STRNCPY	   lstrcpyn
#define CLOSE      closesocket
#define SPRINTF    wsprintf
#define GETPID     _getpid

#else /* !_WINDOWS */

#define STRCHR     strchr
#define	STRCPY	   strcpy
#define STRCMP     strcmp
#define STRLEN     strlen
#define CLOSE      close
#define STRCASECMP strcasecmp
#define	STRNCPY	   strncpy
#define SPRINTF    sprintf
#define GETPID     getpid

#define DWORD unsigned long int
#define WORD  unsigned short int
#define UINT  unsigned int
#define UCHAR unsigned char

#endif /* !_WINDOWS */

/* ******* function ********* */

#ifdef _WINDOWS
void help();
void initLog();
int initApp();
int beginProxy();
extern char *configfile;
void SetWindowsAsyncSelect(HWND hWnd);
void doWinAcception(HWND, SOCKET);

#define PATH_ETC ""

#else /* !_WINDOWS */

#ifndef PATH_ETC
#define PATH_ETC "/etc/"
#endif

#endif /* !_WINDOWS */


#ifdef __cplusplus
}
#endif

/*-----------------------------------------------------------------*/

#endif /* __common_h__ */
